Index: X/.Xdefaults
===================================================================
--- X/.Xdefaults	(revision f30e1cd3c795ada69723131d541c8e45210ffdce)
+++ X/.Xdefaults	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -1,102 +1,50 @@
-*.pointerColor: red
-
-XTerm*utf8: always
-XTerm*metaSendsEscape: true
-
-! Default emacs colors
-XTerm.foreground:  #000000
-XTerm.background:  #ffffff
-XTerm*cursorColor:  red
+!TomorrowNightEighties
+*.foreground:   #cccccc
+*.background:   #2d2d2d
+*.cursorColor:  #aeafad
 
 ! Black / Grey
-!XTerm.color0:       #000000
-XTerm*color8:       #bebebe
+*.color0:       #000000
+*.color8:       #666666
 
 ! Red / Bright Red
-!XTerm*color1:       #8b0000
-XTerm*color9:       #ff4500
+*.color1:       #f2777a
+*.color9:       #FF3334
 
 ! Green + Bright Green
-!XTerm*color2:       #99cc99
-XTerm*color10:      #9ec400
+*.color2:       #99cc99
+*.color10:      #9ec400
 
-! ! Yellow (Orange) + Bright Yellow (Yellow)
-!XTerm*color3:       #cd8500
-XTerm*color11:      #cdcd00
+! Yellow (Orange) + Bright Yellow (Yellow)
+*.color3:       #f99157
+*.color11:      #ffcc66
 
 ! Blue + Bright Blue
-!XTerm*color4:       #6699cc
-XTerm*color12:      #6699cc
+*.color4:       #6699cc
+*.color12:      #6699cc
 
 ! Magenta (Purple) + Bright Magenta
-!XTerm*color5:       #cc99cc
-!XTerm*color13:      #b777e0;
+*.color5:       #cc99cc
+*.color13:      #b777e0
 
 ! Cyan (Aqua) + Bright Cyan
-!XTerm*color6:       #66cccc
-XTerm*color14:      #54ced6
+*.color6:       #66cccc
+*.color14:      #54ced6
 
 ! Light Grey (Selection) + White (Current Line)
-!XTerm*color7:       #515151
-XTerm*color15:      #393939
+*.color7:       #515151
+*.color15:      #393939
 
-! Xterm
-xterm*utf8: 1
-xterm*termName: xterm-256color
-!xterm*loginShell: true
-xterm*locale: true
-xterm*vt100.locale: true
-! xterm*font: x:-misc-fixed-medium-r-normal--14-130-75-75-c-70-iso10646-1
-! xterm*font: x:-misc-fixed-bold-r-normal--15-*-75-75-c-90-iso10646-1
-xterm*font: x:-adobe-courier-bold-r-normal--14-*-75-75-m-90-iso10646-1
-xterm*boldMode: false
-! xterm*font: x:-adobe-courier-medium-r-normal--14-140-75-75-m-90-iso8859-1
-! xterm*boldFont: x:-adobe-courier-medium-r-bold--14-140-75-75-m-90-iso8859-1
-xterm*vt100.allowBoldFonts: True
-xterm*renderFont: True
-xterm.vt100.eightBitInput: False
-xterm*selectToClipboard: True
-xterm*cursorBlink: True
-xterm*cursorColor: red
-xterm*visualBell: True
-xterm*ScrollKey: True
-xterm*saveLines: 5000
-xterm*scaleHeight: 0
-xterm*highlightSelection: True
-xterm.pointerColor: red
+! URxvt
+urxvt*font: xft:terminus:pixelsize=14:autohint=true
+URxvt.scrollBar: false
+URxvt.perl-ext-common: default,selection-to-clipboard,pasta,matcher,keyboard-select
+URxvt.keysym.M-u:     perl:url-select:select_next
+URxvt.underlineURLs:  True
 
-! *font: x:-adobe-courier-medium-r-normal--14-140-75-75-m-90-iso8859-1
-! *font: x:-misc-fixed-medium-r-normal--14-130-75-75-c-70-iso10646-1
-*font: -adobe-courier-bold-r-normal--14-*-75-75-m-90-iso10646-1
-*boldFont: x:-adobe-courier-bold-r-normal--14-*-75-75-m-90-iso10646-1
-*boldMode: false
-
-emacs.toolBar: 0
-emacs.FontBackend: x,xft
-emacs.geometry:=80x49+270+0
-! emacs.font: Unifont-12
-! emacs.font: -adobe-courier-medium-r-normal--14-140-75-75-m-90-iso8859-1
-! emacs.font: -misc-fixed-medium-r-normal--14-130-75-75-c-70-iso10646-1
-emacs.font: -adobe-courier-bold-r-normal--14-*-75-75-m-90-iso10646-1
-emacs.boldFont: -adobe-courier-bold-o-normal--14-*-75-75-m-90-iso10646-1
-! emacs.boldFont: x:-adobe-courier-medium-r-bold--14-140-75-75-m-90-iso8859-1
-emacs.menuBar: 0
-emacs.verticalScrollBars: off
-emacs.cursorColor: red
-emacs.lineSpacing: 0
-emacs.pointerColor: red
-! emacs.minibuffer: none
-
-! emacs.reverseVideo: true
-
-
-! Font Settings
+Xft.autohint: 0
+Xft.lcdfilter: lcddefault
+Xft.hintstyle: hintslight
 Xft.hinting: 0
-Xft.lcdfilter: lcddefault
-Xft.hintstyle: hintnone
 Xft.antialias: 1
-Xft.autohint: 0
 Xft.rgba: rgb
-! Change cursor
-Xcursor.theme: Adwaita
-! Xft.dpi: 96 ! 144
Index: emacs/.emacs
===================================================================
--- emacs/.emacs	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
+++ emacs/.emacs	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -0,0 +1,595 @@
+;;;; My config for Emacs that I use in day-to-day work
+;;;;
+;;;; https://w96k.com/
+;;;; 2018-2019 (c) Mikhail w96k Kirillov
+
+;;;; INIT
+
+;;; Add Melpa repository +
+;;; Load use-package & enable installing all packages by default
+;;; You need to manually install use-package from melpa
+;;; (it's the only package you need to install manually)
+;;; Rest packages will be installed automatically
+;;;
+;;; You need to have "INIT" section and execute:
+;;; M-x package-install RET use-package RET
+
+(eval-when-compile
+  ;; increase GC-limit up to 100M for boot speedup
+  (setq gc-cons-threshold 500000000)
+
+  ;;; Disable emacs gui
+  (menu-bar-mode -1)
+  (scroll-bar-mode -1)
+  (tool-bar-mode -1)
+  (tooltip-mode -1)
+
+  (require 'package)
+
+  (setq package-archives
+        '(("gnu" . "http://elpa.gnu.org/packages/")
+          ("melpa" . "http://melpa.org/packages/")))
+
+  (package-initialize)
+
+  ;; restore GC-limit after timeout
+  (run-with-idle-timer
+   15 nil
+   (lambda ()
+     (setq gc-cons-threshold 100000)))
+
+  ;; Optimize loading
+  (setq load-prefer-newer t
+        package-user-dir "~/.emacs.d/elpa"
+        package--init-file-ensured t
+        package-enable-at-startup nil)
+  
+  (require 'use-package))
+
+(use-package use-package
+  :defer nil
+  :config
+  (setq use-package-verbose t)
+  (setq use-package-always-defer t)
+  (setq use-package-always-ensure nil))
+
+(use-package use-package-ensure-system-package :ensure)
+
+;;;; VISUALS
+
+;;; Display numbers
+(global-display-line-numbers-mode)
+
+;; Display whitespace
+(global-whitespace-mode)
+
+;;; Set font
+(set-frame-font "Terminus" nil t)
+
+;;; Display current line
+(global-hl-line-mode)
+
+;;; Set Theme
+(use-package color-theme-sanityinc-tomorrow
+  :demand
+  :if window-system
+  :config (load-theme 'sanityinc-tomorrow-eighties t))
+
+;;; Powerline
+(use-package powerline
+  :demand
+  :config (powerline-default-theme))
+
+;;; Bullets for org-mode
+(use-package org-bullets
+  :ensure t
+  :commands org-bullets-mode
+  :hook (org-mode . org-bullets-mode))
+
+;;;; EDITING
+
+
+;;; Easy undo system
+(use-package undo-tree
+ :after general
+ :commands
+ (global-undo-tree-mode)
+ :init
+ (setq
+  undo-tree-visualizer-timestamps t
+  undo-tree-enable-undo-in-region nil
+  undo-tree-history-directory-alist
+  `(("." . ,(expand-file-name "undo" user-emacs-directory))))
+ :config
+ (global-undo-tree-mode)
+ :diminish undo-tree-mode)
+
+;;; Jump to defenition
+(use-package dumb-jump
+  :bind (("M-g o" . dumb-jump-go-other-window)
+         ("M-g j" . dumb-jump-go)
+         ("M-g i" . dumb-jump-go-prompt)
+         ("M-g x" . dumb-jump-go-prefer-external)
+         ("M-g z" . dumb-jump-go-prefer-external-other-window))
+  :config (setq dumb-jump-selector 'ivy) ;; (setq dumb-jump-selector 'helm)
+  :ensure)
+
+(progn
+  (show-paren-mode))
+
+;;; Edit with root user
+(use-package sudo-edit)
+
+;;; Look eslint config
+(defun my/use-eslint-from-node-modules ()
+  (let* ((root (locate-dominating-file
+                (or (buffer-file-name) default-directory)
+                "node_modules"))
+         (eslint
+          (and root
+               (expand-file-name "node_modules/.bin/eslint"
+                                 root))))
+    (when (and eslint (file-executable-p eslint))
+      (setq-local flycheck-javascript-eslint-executable eslint))))
+
+;;; Live-checking text
+(use-package flycheck
+  :config
+  (add-hook 'after-init-hook #'global-flycheck-mode)
+  (add-hook 'flycheck-mode-hook #'my/use-eslint-from-node-modules)
+  (setq-default flycheck-disabled-checkers
+                (append flycheck-disabled-checkers
+                        '(javascript-jshint)))
+  (flycheck-add-mode 'javascript-eslint 'web-mode)
+  (setq-default flycheck-temp-prefix ".flycheck"))
+
+;;; No tabs
+(setq-default indent-tabs-mode nil)
+
+;;; Version control
+(use-package magit
+  :defer 2
+  :bind ("C-x g" . magit-status)
+  :config (setq magit-refresh-status-buffer nil))
+
+;;; Magit' github integration
+(use-package magithub
+  :after magit)
+
+;;; Git flow
+(use-package magit-gitflow
+  :after magit
+  :init (add-hook 'magit-mode-hook 'turn-on-magit-gitflow))
+
+;;; Show added & removed git lines
+(use-package git-gutter+
+  :ensure t
+  :init (global-git-gutter+-mode)
+  :config (progn
+            (define-key git-gutter+-mode-map (kbd "C-x n") 'git-gutter+-next-hunk)
+            (define-key git-gutter+-mode-map (kbd "C-x p") 'git-gutter+-previous-hunk)
+            (define-key git-gutter+-mode-map (kbd "C-x v =") 'git-gutter+-show-hunk)
+            (define-key git-gutter+-mode-map (kbd "C-x r") 'git-gutter+-revert-hunks)
+            (define-key git-gutter+-mode-map (kbd "C-x t") 'git-gutter+-stage-hunks)
+            (define-key git-gutter+-mode-map (kbd "C-x c") 'git-gutter+-commit)
+            (define-key git-gutter+-mode-map (kbd "C-x C") 'git-gutter+-stage-and-commit)
+            (define-key git-gutter+-mode-map (kbd "C-x C-y") 'git-gutter+-stage-and-commit-whole-buffer)
+            (define-key git-gutter+-mode-map (kbd "C-x U") 'git-gutter+-unstage-whole-buffer))
+  :diminish (git-gutter+-mode . "gg"))
+
+;;; Autoformatting code
+(use-package aggressive-indent
+  :config (global-aggressive-indent-mode))
+
+;;; 80 column width limit highlighter
+(use-package column-enforce-mode
+  :defer t
+  :diminish
+  :config (80-column-rule)
+  :hook (prog-mode . column-enforce-mode))
+
+;;; General autocomplete
+(use-package ivy
+  :demand
+  :diminish
+  :config
+  (ivy-mode)
+  (setq ivy-use-virtual-buffers t)
+  (setq enable-recursive-minibuffers t)
+  (global-set-key "\C-s" 'swiper)
+  (global-set-key (kbd "C-c C-r") 'ivy-resume)
+  (global-set-key (kbd "<f6>") 'ivy-resume))
+
+(use-package counsel
+  :demand
+  :config
+  (global-set-key (kbd "M-x") 'counsel-M-x)
+  (global-set-key (kbd "C-x C-f") 'counsel-find-file)
+  (global-set-key (kbd "<f1> f") 'counsel-describe-function)
+  (global-set-key (kbd "<f1> v") 'counsel-describe-variable)
+  (global-set-key (kbd "<f1> l") 'counsel-find-library)
+  (global-set-key (kbd "<f2> i") 'counsel-info-lookup-symbol)
+  (global-set-key (kbd "<f2> u") 'counsel-unicode-char)
+  (global-set-key (kbd "C-c g") 'counsel-git)
+  (global-set-key (kbd "C-c j") 'counsel-git-grep)
+  (global-set-key (kbd "C-x b") 'counsel-ibuffer)
+  (global-set-key (kbd "C-c k") 'counsel-ag)
+  (global-set-key (kbd "C-x l") 'counsel-locate)
+  (global-set-key (kbd "C-S-o") 'counsel-rhythmbox)
+  (define-key minibuffer-local-map (kbd "C-r") 'counsel-minibuffer-history))
+
+(use-package ivy-hydra)
+
+(use-package company
+  :demand
+  :diminish
+  :custom
+  (company-require-match nil)
+  (company-minimum-prefix-length 1)
+  (company-idle-delay 0.1)
+  (company-tooltip-align-annotation t)
+  :hook ((prog-mode . company-mode))
+  :config
+  (add-hook 'after-init-hook 'global-company-mode)
+  :bind (:map company-active-map
+              ("C-n" . company-select-next)
+              ("C-p" . company-select-previous)))
+
+;;;; LANGUAGES
+
+;;; Vue
+(use-package vue-mode
+  :config (setq mmm-submode-decoration-level 0))
+
+;;; PHP
+(use-package php-mode)
+
+;;; Templates
+(use-package web-mode
+  :config
+  (add-to-list 'auto-mode-alist '("\\.html?\\'" . web-mode))
+  ())
+
+;;; Javascript
+(use-package js2-mode
+  :config
+  (add-to-list 'auto-mode-alist '("\\.js\\'" . js2-mode))
+  (setq-default js2-basic-offset 2)
+  (add-hook 'js2-mode-hook
+            (lambda ()
+              (define-key js-mode-map (kbd "C-x C-e") 'nodejs-repl-send-last-expression)
+              (define-key js-mode-map (kbd "C-c C-j") 'nodejs-repl-send-line)
+              (define-key js-mode-map (kbd "C-c C-r") 'nodejs-repl-send-region)
+              (define-key js-mode-map (kbd "C-c C-l") 'nodejs-repl-load-file)
+              (define-key js-mode-map (kbd "C-c C-z") 'nodejs-repl-switch-to-repl))))
+
+;;; Eslint
+(use-package eslint-fix
+  :ensure-system-package (eslint . "npm install -g eslint")
+  :config
+  (eval-after-load 'js2-mode
+    '(add-hook 'js2-mode-hook (lambda () (add-hook 'after-save-hook 'eslint-fix nil t)))))
+
+(use-package json-mode)
+
+(use-package rjsx-mode
+  :config
+  (add-to-list 'auto-mode-alist '(".*\.js\'" . rjsx-mode)))
+
+;;; Yasnippet
+(use-package yasnippet
+  :demand
+  :diminish
+  :config (yas-global-mode 1))
+
+(use-package yasnippet-snippets
+  :diminish
+  :after yasnippet)
+
+;;; LSP
+(use-package lsp-mode
+  :hook
+  (ruby-mode . lsp)
+  (javascript-mode . lsp)
+  (vue-mode . lsp)
+  :commands lsp)
+
+;;; LSP Flycheck
+(use-package lsp-ui
+  :after (lsp-mode)
+  :hook lsp-mode
+  :commands lsp-ui-mode)
+
+(use-package company-lsp
+  :after (lsp-mode lsp-ui)
+  :commands company-lsp)
+
+;;; Debugger
+(use-package dap-mode
+  :config
+  (dap-mode 1)
+  (dap-ui-mode 1))
+
+;;; Ruby On Rails
+(use-package rinari)
+
+;;; Node.js Repl
+(use-package nodejs-repl)
+
+;;; Haskell support
+(use-package intero
+  :config (add-hook 'haskell-mode-hook 'intero-mode))
+
+;;; Typescript support
+(use-package typescript-mode)
+
+(use-package tide
+  :ensure t
+  :diminish
+  :after (typescript-mode company flycheck)
+  :hook ((typescript-mode . tide-setup)
+         (typescript-mode . tide-hl-identifier-mode)
+         (before-save . tide-format-before-save)))
+
+;;; Clojure REPL
+(use-package cider)
+
+;;;; MISC
+
+(use-package exec-path-from-shell
+  :config
+  (when (memq window-system '(mac ns x))
+    (exec-path-from-shell-initialize)
+    (exec-path-from-shell-copy-env "PATH")))
+
+;; Kill whole line
+(global-set-key (kbd "C-u") 'kill-whole-line)
+
+;;; Volume management using thinkpad volume buttons
+(use-package volume
+  :config
+  (global-set-key (kbd "<XF86AudioRaiseVolume>") 'volume-raise-10)
+  (global-set-key (kbd "<XF86AudioLowerVolume>") 'volume-lower-10))
+
+;;; Screenshot
+(use-package frameshot
+  :config (frameshot-setup
+           '((name   . "w96k")
+             (height . 800)
+             (width  . 1280))))
+
+;;; Change Move to end & beginning of the line behavior
+(use-package mvim
+  :config
+  (global-set-key (kbd "C-a") 'mwim-beginning)
+  (global-set-key (kbd "C-e") 'mwim-end))
+
+(use-package command-log-mode)
+
+;;; Benchmark init
+(use-package benchmark-init
+  :demand
+  :ensure t
+  :config
+  ;; To disable collection of benchmark data after init is done.
+  (add-hook 'after-init-hook 'benchmark-init/deactivate))
+
+;;; Bug-Tracker DebBugs
+(use-package debbugs)
+
+;;; Icons
+(use-package all-the-icons)
+
+;;; Icons for dired
+(use-package all-the-icons-dired
+  :diminish
+  :after all-the-icons
+  :config
+  (add-hook 'dired-mode-hook 'all-the-icons-dired-mode))
+
+;;; Sidebar File-Manager
+(use-package dired-sidebar
+  :after exwm
+  :bind (("C-x C-n" . dired-sidebar-toggle-sidebar))
+  :diminish
+  :after all-the-icons
+  :commands (dired-sidebar-toggle-sidebar)
+  :init
+  (add-hook 'dired-sidebar-mode-hook
+            (lambda ()
+              (unless (file-remote-p default-directory)
+                (auto-revert-mode))))
+  :config
+  (push 'toggle-window-split dired-sidebar-toggle-hidden-commands)
+  (push 'rotate-windows dired-sidebar-toggle-hidden-commands)
+  (setq dired-sidebar-subtree-line-prefix "__")
+  (setq dired-sidebar-use-term-integration t)
+  (setq dired-sidebar-use-custom-font t))
+
+;;; Manage docker in emacs
+(use-package docker
+  :bind ("C-c d" . docker))
+
+;;; hide some minor modes
+(use-package diminish
+  :demand)
+
+;;; org
+(use-package org
+  :config
+  (setq org-todo-keywords
+        (quote ((sequence "TODO(t)" "MIGRATE(m)" "|" "DONE(d)")
+                (sequence "WAITING(w@/!)" "HOLD(h@/!)" "|" "CANCELLED(c@/!)" "PHONE" "MEETING"))))
+  (setq org-todo-keyword-faces
+        (quote (("TODO" :foreground "red" :weight bold)
+                ("NEXT" :foreground "blue" :weight bold)
+                ("DONE" :foreground "forest green" :weight bold)
+                ("WAITING" :foreground "orange" :weight bold)
+                ("HOLD" :foreground "magenta" :weight bold)
+                ("CANCELLED" :foreground "forest green" :weight bold)
+                ("MEETING" :foreground "forest cyan" :weight bold)
+                ("PHONE" :foreground "blue" :weight bold)))))
+
+;;; Smart mode line
+(use-package smart-mode-line
+  :demand
+  :config
+  (setq sml/no-confirm-load-theme t)
+  (setq sml/theme 'respectful)
+  (sml/setup))
+
+;;; Delete trailing whitespace on save
+(use-package whitespace-cleanup-mode
+  :diminish
+  :config (global-whitespace-cleanup-mode))
+
+;;; convert org to html in gnus
+(use-package org-mime)
+
+;;; Presentation
+(use-package epresent)
+
+;;; Email
+(use-package pinentry
+  :config
+  (setq epa-pinentry-mode 'loopback)
+  (pinentry-start))
+
+;;; Guru mode (disable arrows and stuff)
+(use-package guru-mode
+  :diminish
+  :config (guru-global-mode +1))
+
+;;; Hackernews
+(use-package hackernews)
+
+;;; PDF Tools
+(use-package pdf-tools
+  :demand
+  :config (pdf-loader-install))
+
+;;; Twitter
+(use-package twittering-mode
+  :config (setq twittering-use-master-password t))
+
+;;; Short messages
+(defalias 'yes-or-no-p 'y-or-n-p)
+
+(setq-default confirm-nonexistent-file-or-buffer t)
+
+(setq
+ save-place-forget-unreadable-files t
+ save-place-limit 200)
+
+(save-place-mode 1)
+
+;;; Browser
+(use-package w3m)
+
+;;; Show Emoji in emacs
+(use-package emojify
+  :config (add-hook 'after-init-hook #'global-emojify-mode))
+
+
+;;; Server for editing web-forms in emacs
+(use-package edit-server
+  :if window-system
+  :config (edit-server-start))
+
+;;; Markdown preview
+(use-package flymd)
+
+;;; AG Search
+(use-package ag)
+
+;;; Remove permission info from dired
+(defun dired-mode-setup ()
+  "to be run as hook for `dired-mode'."
+  (dired-hide-details-mode 1))
+(add-hook 'dired-mode-hook 'dired-mode-setup)
+
+;;; Dired Ranger like
+(use-package peep-dired)
+
+;;; Project Management
+(use-package projectile
+  :diminish 
+  :bind (("s-p" . projectile-command-map)
+         ("C-c p" . projectile-command-map))
+  :config
+  (projectile-global-mode))
+
+;;; Editor Config support
+(use-package editorconfig
+  :ensure t
+  :diminish
+  :config
+  (editorconfig-mode 1))
+
+;;; Parens editing
+(use-package paredit)
+
+;;; Parens colorizing
+(use-package rainbow-delimiters)
+
+;;; Break line at 80 symbols
+(setq fill-column 80)
+
+;;; Disable mouse
+(use-package disable-mouse
+  :diminish 
+  :defer 5
+  :config (global-disable-mouse-mode))
+
+
+(setq create-lockfiles nil)
+(setq
+ make-backup-files nil        ; disable backup files
+ auto-save-list-file-name nil ; disable .saves files
+ auto-save-default nil        ; disable auto saving
+ ring-bell-function 'ignore)  ; turn off alarms completely
+
+;;; No savefiles
+(progn
+  (setq make-backup-files nil)
+  (setq auto-save-default nil)
+  (setq create-lockfiles nil))
+
+;;; Org-mode Setup
+(setq org-agenda-files (list
+                        "~/Documents/life.org"))
+
+;;; Pomodoro technique tracking for org-mode
+(use-package org-pomodoro)
+
+;;; Hugo org exporter
+(use-package ox-hugo
+  :after oxxb
+  :config
+  (setq org-hugo-default-section-directory "posts")
+  (setq HUGO_BASE_DIR "~/github/w96k.gitlab.io/content/"))
+
+;;; Accounting
+(use-package ledger-mode)
+
+;;; Diary
+(use-package org-journal)
+
+;;; Display whitespace
+(progn
+  (setq whitespace-style (quote (face spaces tabs
+                                      space-mark tab-mark newline-mark )))
+  (setq whitespace-display-mappings
+        '(
+          (space-mark 32 [183] [46])
+          (tab-mark 9 [9655 9] [92 9])
+          ))
+
+  (set-face-attribute 'whitespace-space nil :background nil
+                      :foreground "gray30")
+  (set-face-attribute 'whitespace-newline nil :background nil
+                      :foreground "gray30")
+  (set-face-attribute 'whitespace-tab nil :background nil
+                      :foreground "gray30"))
+
+(add-to-list 'exec-path "~/.nodejs/bin/")
Index: emacs/.gnus
===================================================================
--- emacs/.gnus	(revision f30e1cd3c795ada69723131d541c8e45210ffdce)
+++ emacs/.gnus	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -1,47 +1,49 @@
-(setq epa-file-cache-passphrase-for-symmetric-encryption t)
+(setq ;; You need to replace this email address with your own!
+ user-mail-address "w96k.ru@gmail.com"
+ ;; You need to replace this key ID with your own key ID!
+ mml-secure-openpgp-signers '("08948CB6")
+ ;; This tells Gnus to get email from Gmail via IMAP.
+ gnus-select-method
+ '(nnimap "gmail"
+          ;; It could also be imap.googlemail.com if that's your server.
+          (nnimap-address "imap.gmail.com")
+          (nnimap-server-port 993)
+          (nnimap-stream ssl))
+ ;; This tells Gnus to use the Gmail SMTP server. This
+ ;; automatically leaves a copy in the Gmail Sent folder.
+ smtpmail-smtp-server "smtp.gmail.com"
+ smtpmail-smtp-service 587
+ ;; Tell message mode to use SMTP.
+ message-send-mail-function 'smtpmail-send-it
+ ;; Gmail system labels have the prefix [Gmail], which matches
+ ;; the default value of gnus-ignored-newsgroups. That's why we
+ ;; redefine it.
+ gnus-ignored-newsgroups "^to\\.\\|^[0-9. ]+\\( \\|$\\)\\|^[\"]\"[#'()]"
+ ;; The agent seems to confuse nnimap, therefore we'll disable it.
+ gnus-agent nil
+ ;; We don't want local, unencrypted copies of emails we write.
+ gnus-message-archive-group nil
+ ;; We want to be able to read the emails we wrote.
+ mml-secure-openpgp-encrypt-to-self t)
 
-(with-eval-after-load "mail-source"
-  (add-to-list 'mail-sources '(pop :name "runbox"
-	    :server "mail.runbox.com"
-            :user "w96k"
-	    :leave 3
-	    )))
+;; Attempt to encrypt all the mails we'll be sending.
+(add-hook 'message-setup-hook 'mml-secure-message-encrypt)
 
+;; Add two key bindings for your Gmail experience.
+(add-hook 'gnus-summary-mode-hook 'my-gnus-summary-keys)
 
-(setq user-mail-address "w96k@runbox.com"
-      user-full-name "Mikhail Kirillov")
+(defun my-gnus-summary-keys ()
+  (local-set-key "y" 'gmail-archive)
+  (local-set-key "$" 'gmail-report-spam))
 
-(setq gnus-select-method '(nnml ""))
+(defun gmail-archive ()
+  "Archive the current or marked mails.
+This moves them into the All Mail folder."
+  (interactive)
+  (gnus-summary-move-article nil "nnimap+imap.gmail.com:[Gmail]/All Mail"))
 
-(add-to-list 'gnus-secondary-select-methods '(nntp "news.eternal-september.org"))
-(add-to-list 'gnus-secondary-select-methods '(nntp "news.gmane.io"))
-
-;; (add-to-list 'gnus-secondary-select-methods '(nnimap "gmail"
-;;                (nnimap-address "imap.gmail.com")
-;;                (nnimap-server-port 993)
-;;                (nnimap-stream ssl)))
-
-(setq gnus-use-cache t
-      send-mail-function 'smtpmail-send-it
-      message-send-mail-function 'smtpmail-send-it
-      smtpmail-smtp-server "mail.runbox.com"
-      ;; smtpmail-smtp-service 587
-      ;; smtpmail-stream-type 'starttls
-      smtpmail-stream-type  'ssl
-      smtpmail-smtp-service 465
-      mml-secure-openpgp-signers '("CE73F35DE039B8D52039A12CB643528AA92DE506")
-      mml-secure-openpgp-encrypt-to-self t
-      gnus-ignored-newsgroups "^to\\.\\|^[0-9. ]+\\( \\|$\\)\\|^[\"]\"[#'()]")
-
-(setq starttls-use-gnutls t)
-(setq starttls-gnutls-program "gnutls-cli")
-(setq starttls-extra-arguments nil)
-(setq smtpmail-servers-requiring-authorization ".*")
-
-(add-hook 'message-setup-hook 'mml-secure-message-encrypt)
-(add-hook 'message-setup-hook 'mml-secure-message-sign)
-
-(setq mm-automatic-display (remove "text/html" mm-automatic-display))
-
-(add-hook 'gnus-group-mode-hook 'gnus-topic-mode)
-
+(defun gmail-report-spam ()
+  "Report the current or marked mails as spam.
+This moves them into the Spam folder."
+  (interactive)
+  (gnus-summary-move-article nil "nnimap+imap.gmail.com:[Gmail]/Spam"))
Index: eslint/.eslintrc
===================================================================
--- eslint/.eslintrc	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
+++ eslint/.eslintrc	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -0,0 +1,43 @@
+{
+    "parser": "babel-eslint",
+    "plugins": [ "react" ],
+    "extends": "airbnb-base",
+    "env": {
+        "browser": true,
+        "es6": true,
+        "node": true
+    },
+    "parserOptions": {
+        "ecmaFeatures": {
+            "jsx": true,
+            "modules": true
+        },
+        "sourceType": "module"
+    },
+    "ecmaFeatures": {
+        "arrowFunctions": true,
+        "blockBindings": true,
+        "classes": true,
+        "defaultParams": true,
+        "destructuring": true,
+        "forOf": true,
+        "generators": true,
+        "modules": true,
+        "spread": true,
+        "templateStrings": true,
+        "jsx": true
+    },
+    "rules": {
+        "consistent-return": [0],
+        "key-spacing": [0],
+        "quotes": [0],
+        "new-cap": [0],
+        "no-multi-spaces": [0],
+        "no-shadow": [0],
+        "no-unused-vars": [1],
+        "no-use-before-define": [2, "nofunc"],
+        "react/jsx-no-undef": 1,
+        "react/jsx-uses-react": 1,
+        "react/jsx-uses-vars": 1
+    }
+}
Index: gnupg/.gnupg/gpg-agent.conf
===================================================================
--- gnupg/.gnupg/gpg-agent.conf	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
+++ gnupg/.gnupg/gpg-agent.conf	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -0,0 +1,1 @@
+pinentry-program /gnu/store/az8b2s2d2hiyd5gmih39ilp71al3s5x5-profile/bin/pinentryn
Index: guix/.bash_profile
===================================================================
--- guix/.bash_profile	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
+++ guix/.bash_profile	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -0,0 +1,26 @@
+# Add npm to PATH
+export PATH="~/.nodejs/bin/:$PATH"
+
+# Add .bin to PATH
+export PATH="~/.bin/:$PATH"
+
+# Add ruby gems to PATH
+export PATH=$PATH:/home/w96k/.gem/
+export PATH=$PATH:/home/w96k/.gem/ruby/2.5.0/bin/
+
+# Add nix to PATH
+export PATH=$PATH:/nix/var/nix/profiles/default/bin/
+
+# Add custom packages to guix PATH
+export GUIX_PACKAGE_PATH=~/.guix-packages
+
+# Proxy
+export http_proxy=http://127.0.0.1:9050/
+export https_proxy=$http_proxy
+
+setxkbmap -layout us,ru -option grp:caps_toggle
+
+if [ -f .bashrc ]
+then
+    . .bashrc
+fi
Index: guix/.bashrc
===================================================================
--- guix/.bashrc	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
+++ guix/.bashrc	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -0,0 +1,31 @@
+# Bash initialization for interactive non-login shells and
+# for remote shells (info "(bash) Bash Startup Files").
+
+# Export 'SHELL' to child processes.  Programs such as 'screen'
+# honor it and otherwise use /bin/sh.
+export SHELL
+
+if [[ $- != *i* ]]
+then
+    # We are being invoked from a non-interactive shell.  If this
+    # is an SSH session (as in "ssh host command"), source
+    # /etc/profile so we get PATH and other essential variables.
+    [[ -n "$SSH_CLIENT" ]] && source /etc/profile
+
+    # Don't do anything else.
+    return
+fi
+
+# Source the system-wide file.
+source /etc/bashrc
+
+# Adjust the prompt depending on whether we're in 'guix environment'.
+if [ -n "$GUIX_ENVIRONMENT" ]
+then
+    PS1='\u@\h \w [env]\$ '
+else
+    PS1='\u@\h \w\$ '
+fi
+alias ls='ls -p --color=auto'
+alias ll='ls -l'
+alias grep='grep --color=auto'
Index: guix/.config/fontconfig/fonts.conf
===================================================================
--- guix/.config/fontconfig/fonts.conf	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
+++ guix/.config/fontconfig/fonts.conf	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -0,0 +1,39 @@
+<?xml version="1.0"?>
+<!DOCTYPE fontconfig SYSTEM "fonts.dtd">
+<fontconfig>
+
+  <match>
+	<test name="family"><string>sans-serif</string></test>
+	<edit name="family" mode="prepend" binding="strong">
+		<string>Terminus</string>
+	</edit>
+	<edit name="family" mode="append" binding="strong">
+		<string>Terminus</string>
+
+	</edit>
+</match>
+<match>
+	<test name="family"><string>serif</string></test>
+	<edit name="family" mode="prepend" binding="strong">
+		<string>Terminus</string>
+	</edit>
+</match>
+<match>
+	<test name="family"><string>monospace</string></test>
+	<edit name="family" mode="prepend" binding="strong">
+		<string>Terminus</string>
+	</edit>
+</match>
+
+<match target="font">
+    <edit name="antialias" mode="assign">
+      <bool>true</bool>
+    </edit>
+  </match>
+    <match target="font">
+    <edit name="hinting" mode="assign">
+      <bool>true</bool>
+    </edit>
+  </match>
+
+</fontconfig>
Index: guix/.config/nixpkgs/config.nix
===================================================================
--- guix/.config/nixpkgs/config.nix	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
+++ guix/.config/nixpkgs/config.nix	(revision c39b1a4ec77441181684e04b57c3b58087940bc7)
@@ -0,0 +1,5 @@
+{
+  allowUnfree = true;
+
+  boot.kernel.sysctl."vm.overcommit_memory" = "1";
+}
